#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sun Dec 24 15:40:09 2017

@author: boiboite
"""
"---------------------------------------------------------------"
"---------------------------------------------------------------"
"---------------------------------------------------------------"
"Représentation graphique de la position d'une fonction quelconque f(x) sur [a ; b]"
"L'objectif est de représenter différemment les points d'ordonnées y = f(x) < k "
"    de ceux d'ordonnées y = f(x) > k, soit par la couleur, soit par les marques."
"---------------------------------------------------------------"

"Quelques exemples de fonctions avec leurs domaines de définition [a ; b]"
"et le nombre de points nbpoints servant à tracer la représentation graphique"
"PAS DE FONCTION CONSTANTE !!"

def h(x):
    return (-2 * x + 4) # sur l'intervalle [-0.5 ; 2.5]

def i(x):
    return (3 * x - 1)  # sur l'intervalle  [-0.5 ; 2.5]

def m(x):
    return (x + 1 / 2)  # sur l'intervalle  [-1.5 ; 3.5]

def j(x):
    return (- x**2 + 2 * x + 3)  # sur l'intervalle  [-1.5 ; 3.5]

def k(x):
    return (x**2 - 2 * x - 5)  # sur l'intervalle  [-2 ; 4]

def p(x):
    return (x**3 + 2 * x**2 - x - 2)  # sur l'intervalle  [-2.5 ; 1.5]

def q(x):
    return ((x - 4)**4 / 10 + (x - 4)**3 + 2 * (x - 4)**2 - 3 * (x - 4) - 4)
                             # sur l'intervalle  [-2.5 ; 5.8]

"------------------algorithme fgene.posi2---------------------------"
"---------------------------------------------------------------"
"Représentation graphique, algorithme fgene.posi2 en lignes de commandes"
"Un seul tableau (1 ligne) contient les couleurs de chaque point"
"Scatter permet d'affecter une couleur à chaque point avec une liste scy"
"    des couleurs des points de f,  en paramètre"
"Dommage qu'on ne puisse pas faire la même chose avec les markers !!"
"Exécuter fonction f puis bornes domaine, k et nbpoints"

"Importation des bibliothèques suffisantes"
import numpy as np
import matplotlib.pyplot as plt

"Calcul des abscisses et des ordonnées des nbpoints points"
"Ce sont des 'array' car on utilise np"
"Sans numpy on ne peut pas faire y = f(x), il faudrait faire une boucle"
x = np.linspace(a, b, nbpoints)
y = f(x)

couleur = ['green', 'blue']
signy = (y < k) * 1
scy = [couleur[i] for i in signy]

plt.figure()
plt.scatter(x, y, s = 30, marker = 'o', color = scy, edgecolors = 'none')
plt.plot(x, [k] * nbpoints, 'r-')
plt.title('Représentation graphique de la fonction affine f')
plt.xlabel('Abscisses X')
plt.ylabel('Ordonnées Y')
plt.text(min(x), max(y), 'f inférieure à k en bleu\nf supérieure à k en vert',
         verticalalignment = 'top', horizontalalignment = 'left')
plt.grid()
plt.show()

"--------------"
plt.clf()

plt.close()

del(np, plt, a, b, nbpoints, f, p, k, x, y, signy, scy, couleur)


"---------------------------------------------------------------"
"Une fonction Python3 correspondant à l'algorithme fgene.posi2"
"Exécuter fonction f puis bornes domaine, k et nbpoints"
def PositFgene2():
    import numpy as np
    import matplotlib.pyplot as plt
    x = np.linspace(a, b, nbpoints)
    y = f(x)
    couleur = ['green', 'blue']
    signy = (y < k) * 1
    scy = [couleur[i] for i in signy]
    plt.figure()
    plt.scatter(x, y, s = 30, marker = 'o', color = scy, edgecolors = 'none')
    plt.plot(x, [k] * nbpoints, 'r-')
    plt.title('Représentation graphique de la fonction affine f')
    plt.xlabel('Abscisses X')
    plt.ylabel('Ordonnées Y')
    plt.text(min(x), max(y), 'f inférieure à k en bleu\nf supérieure à k en vert',
         verticalalignment = 'top', horizontalalignment = 'left')
    plt.grid()
    plt.show()


"---------------------algorithme fgene.posi4 -------------------------"
"---------------------------------------------------------------"
"Représentation graphique, algorithme fgene.posi4 en lignes de commandes"
"Un seul tableau (1 ligne) contient les couleurs de chaque point"
"Scatter permet d'affecter une couleur à chaque point avec une liste scy"
"    des couleurs des points de f,  en paramètre"
"Dommage qu'on ne puisse pas faire la même chose avec les markers !!"
"Exécuter fonction f puis bornes domaine, k et nbpoints"

"Importation des bibliothèques suffisantes"
import numpy as np
import matplotlib.pyplot as plt

"Je reprends deux fonctions du haut du fichier"
"Je copie les fonctions en changeant de nom"
"Je saisis le domaine de définition et le nombre de points"
def m(x):
    return (x + 1 / 2)  # sur l'intervalle  [-1.5 ; 3.5]

def j(x):
    return (- x**2 + 2 * x + 3)  # sur l'intervalle  [-1.5 ; 3.5]

f = k
g = p
a = -3 ; b = 3 ; nbpoints = 100


"Calcul des abscisses et des ordonnées des nbpoints points"
"Ce sont des 'array' car on utilise np"
"Sans numpy on ne peut pas faire y = f(x), il faudrait faire une boucle"
x = np.linspace(a, b, nbpoints)
y = f(x)
z = g(x)

couleur = ['green', 'blue']
posiz = (z < y) * 1
scz = [couleur[i] for i in posiz]

plt.figure()
plt.scatter(x, y, s = 20, marker = 'o', color = 'black', edgecolors = 'none', label = 'Fonction f')
plt.scatter(x, z, s = 20, marker = 'x', color = scz, edgecolors = 'none', label  = 'Fonction g')
plt.title('Représentation graphique des fonctions f et g')
plt.xlabel('Abscisses X')
plt.ylabel('Ordonnées Y')
plt.text(min(x), max(y), 'g inférieure à f en bleu\ng supérieure à f en vert',
         verticalalignment = 'top', horizontalalignment = 'left')
plt.legend(loc = 1)
plt.grid()
plt.show()


"---------------------------------------------------------------"
"Une fonction Python3 correspondant à l'algorithme fgene.posi4"
"Exécuter fonctions f et g puis bornes domaine et nbpoints"
def PositFgene4():
    import numpy as np
    import matplotlib.pyplot as plt






    plt.figure()
    plt.plot(x, y, 'k-', label = 'Fonction f')
    plt.scatter(x, z, s = 20, marker = 'x', color = scz, edgecolors = 'none', label  = 'Fonction g')
    plt.title('Représentation graphique des fonctions f et g')
    plt.xlabel('Abscisses X')
    plt.ylabel('Ordonnées Y')
    plt.text(min(x), max(max(y), max(z)), 'g inférieure à f en bleu\ng supérieure à f en vert',
             verticalalignment = 'top', horizontalalignment = 'left')
    plt.legend(loc = 'center left')
    plt.grid()
    plt.show()


