#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sat Dec 16 01:48:32 2017

@author: bubu
"""

"-------------------- LES DISTRIBUTIONS SIMULÉES ---------------------"

"------------------- ALGO S3-1 ----------------------------------"
"Distribution simulée de la somme S3d des faces de trois dés à 6 faces équilibrées"
"Le tableau des effectifs est construit au fur et à mesure des lancers."
"Le lancer des dés est fait dans une boucle et l'effectif des numéros obtenus"
"    augmente de 1 à chaque tour."
"La liste des effectifs des 16 valeurs (3 à 18) est initialisée à 0."
from random import randint
from matplotlib import pyplot as plt
nbsim = 10
serieEffectifs = [0] * 16
for n in range(nbsim):
    de1 = randint(1, 6)
    de2 = randint(1, 6)
    de3 = randint(1, 6)
    troisDes = de1 + de2 + de3
    serieEffectifs[troisDes - 3] += 1
tabloEffec = dict(zip(range(3, 19), serieEffectifs))
serieFreq = [round(serieEffectifs[i] / nbsim, 4) for i in range(16)]
tabloFreq = dict(zip(range(3, 19), serieFreq))
tabloEffec
tabloFreq
"-----Le graphique en barres du tableau des fréquences simulées------"
x = range(3, 19)
plt.figure()
plt.grid()
plt.bar(x, serieFreq, color = 'green') ; plt.xticks(x)
plt.title("DISTRIBUTION SIMULÉE DE LA VARIABLE S3d")
plt.xlabel("VALEURS DE S3d SOMME DES TROIS CHIFFRES OBTENUS")
plt.ylabel("FRÉQUENCE SIMULÉE")
plt.show()


"---------------- ALGO S3-1 ---------------------------------------"
"Une fonction python correspondant"
def S3d_1(nbsim):
    from random import randint
    from matplotlib import pyplot as plt
    serieEffectifs = [0] * 16
    for n in range(nbsim):
        de1 = randint(1, 6)
        de2 = randint(1, 6)
        de3 = randint(1, 6)
        troisDes = de1 + de2 + de3
        serieEffectifs[troisDes - 3] += 1
    tabloEffec = dict(zip(range(3, 19), serieEffectifs))
    serieFreq = [round(serieEffectifs[i] / nbsim, 4) for i in range(16)]
    tabloFreq = dict(zip(range(3, 19), serieFreq))
    print(tabloEffec)
    print(tabloFreq)
    "-----Le graphique en barres du tableau des fréquences simulées------"
    x = range(3, 19)
    plt.figure()
    plt.grid()
    plt.bar(x, serieFreq, color = 'green') ; plt.xticks(x)
    plt.title("DISTRIBUTION SIMULÉE DE LA VARIABLE S3d")
    plt.xlabel("VALEURS DE S3d SOMME DES TROIS CHIFFRES OBTENUS")
    plt.ylabel("FRÉQUENCE SIMULÉE")
    plt.show()


"---------------- LA DISTRIBUTION DE PROBABILITÉS ------------------"
"---------------- ALGO P-S3-1 ---------------------------------------"
"Univers de la variable aléatoire S3d : somme des faces de trois dés équilibrés à six faces"
"Tableau des effectifs des valeurs de la v.a. S3d"
"Distribution de probabilité de la v.a. S3d"

UniversTriplets = tuple((i, j, k) for i in range(1, 7) for j in range(1, 7) for k in range(1, 7))
cardUniversTriplets = len(UniversTriplets)
UnivS3d = [sum(UniversTriplets[i]) for i in range(cardUniversTriplets)]
"Un autre codage du même algorithme"
# UnivS3d = tuple(i + j + k for i in range(1, 7) for j in range(1, 7) for k in range(1, 7))
listeEff = [0] * 16
for k in range(cardUniversTriplets):
    listeEff[UnivS3d[k] - 3] += 1
Proba = [round(listeEff[i] / cardUniversTriplets, 4) for i in range(16)]
tabloEffec = dict(zip(range(3, 19), listeEff))
tabloProba = dict(zip(range(3, 19), Proba))
tabloEffec
tabloProba

"-----Le graphique en barres de la distribution de probabilité de S3d -----"
from matplotlib import pyplot as plt
x = range(3, 19)
plt.figure()
plt.bar(x, Proba) ; plt.xticks(x)
plt.title("DISTRIBUTION DE PROBABILITÉ DE LA VARIABLE S3d")
plt.xlabel("VALEURS DE S3d SOMME DES TROIS CHIFFRES OBTENUS")
plt.ylabel("PROBABILITÉ")
plt.grid()
plt.show()

"---------------- ALGO P-S3-2 ---------------------------------------"
"Une fonction python correspondant"
def probaS3d():
    from matplotlib import pyplot as plt
    UnivS3d = tuple(i + j + k for i in range(1, 7) for j in range(1, 7) for k in range(1, 7))
    cardUniversS3d = len(UnivS3d)
    listeEff = [0] * 16
    for k in range(cardUniversS3d):
        listeEff[UnivS3d[k] - 3] += 1
    Proba = [round(listeEff[i] / cardUniversS3d, 4) for i in range(16)]
    tabloProba = dict(zip(range(3, 19), Proba))
    print(tabloProba)
    x = range(3, 19)
    plt.figure()
    plt.bar(x, Proba) ; plt.xticks(x)
    plt.title("DISTRIBUTION DE PROBABILITÉ DE LA VARIABLE S3d")
    plt.xlabel("VALEURS DE S3d SOMME DES TROIS CHIFFRES OBTENUS")
    plt.ylabel("PROBABILITÉ")
    plt.grid()
    plt.show()



